#!/bin/sh
#
#############################################
if [[ -n "${16}" ]]
 then
  DATA="${1%.conf*}.data"
  mv "${15}" "$DATA"
  DAT="
datafile  = $DATA"
else
  DAT=""
fi
if [[ -n "${17}" ]]
 then
  PCT="
postct    = ${17}"
else
  PCT=""
fi
cat >"$1" <<EOF
# $1
#
# Konfigurationsdatei für test_web
#
# test_web prüft die Verfügbarkeit von Web-Seiten
#
# Format:
# [minutes   =]        Minuten (wie in crontab)
# [hours     =]        Stunden (wie in crontab)
# [hostname  =]        Hostname im ULS
# section   =          Section im ULS
# teststep  =          Teststep im ULS
# [detail    =]        Detail im ULS
# typ       =          I|X|H|T|Z|S|O
# url       =          Internet URL
# [followredirect =]   Redirect folgen
# [proxy     =]        ggf. Proxy
# [timeout   =]        Timeout in Sekunden
# [storefile =]        Dateiname
# [httpreturncode =]   HTTP-Returncode speichern
# [getcertinfo =]      SSL-Zertifikatinfo
# [postct    =]        Content-Type der Post-Daten
# [postdata  =]        Dateiname der Post-Daten
#
# Typen: I - Image
#        X - Xml
#        H - Html
#        P - PDF
#        Z - ZIP
#        S - SOAP
#        O - Other
#
##########################################################
#
minutes        = ${11}
hours          = ${12}
hostname       = $2
section        = $3
teststep       = $4
detail         = $5
typ            = $6
url            = $7
followredirect = ${13}
proxy          = $8
timeout        = $9
httpreturncode = ${14}
getcertinfo    = ${15}
storefile      = ${10}$DAT$PCT
EOF
#
#
cat "$1"
